
// this version is more like the C code, but not what Java programmers do
class Acct1 {
    int balance = 0;
    Object lock = new Object(); // everything is a lock
    
    boolean withdraw(int amt) {
	synchronized(lock) {
	    if(balance < amt)
		return false; // more Java-like: throw an exception
	    balance -= amt;
	    return true; // lock still gets released (above too)
	}
    }
    boolean deposit(int amt) {
	synchronized(lock) {
	    balance += amt;
	}
	return true;
    }
}

// this version uses this for mutual exclusion
class Acct2 {
    int balance = 0;
    
    boolean withdraw(int amt) {
	synchronized(this) {
	    if(balance < amt)
		return false; // more Java-like: throw an exception
	    balance -= amt;
	    return true; // could be in synchronized, lock still gets released
	}
    }
    boolean deposit(int amt) {
	synchronized(this) {
	    balance += amt;
	}
	return true;
    }
}

// this version is identical to Acct2 with fewer keystrokes
class Acct3 {
    int balance = 0;
    
    synchronized boolean withdraw(int amt) {
	if(balance < amt)
	    return false; // more Java-like: throw an exception
	balance -= amt;
	return true; // could be in synchronized, lock still gets released
    }
    synchronized boolean deposit(int amt) {
	balance += amt;
	return true;
    }
}

